%Given the cost vectors (c1,c2,c3), the number of grids for scores n, and
%the number of grids for prize values m, this function gives the value of
%the first prize v1 in the optimal allocation of prizes.

function [v1star] = optimalprize(c1,c2,c3,n,m_v)
%n is the number of grids for scores
%m_v is the number of grids for prizes
%v1star is the optimal first prize

%record total effort in E and prizes in V
E=zeros(m_v+1,1);
V=zeros(m_v+1,1);

l_v=0.5/m_v; %length of intervals for v1, v2;
for i=1:m_v+1;
    v1=1/2+l_v*(i-1);
    v2=1-v1;
    v3=0;
    V(i)=v1;
    [es u]=outcome(v1,v2,v3,c1,c2,c3,n);
    E(i)=sum(es);
end;

%find the optimal prize:
[maxE,v1_index]=max(E);
v1star=V(v1_index);
