%This function gives the mixed strategies G1, G2, G3 in the three-player 
%contest with distinct prizes

function [G1 G2 G3 S gaps3 u1 u2 u3]=solveG(v1, v2, v3, C, n)

    c1=C(1);
    c2=C(2);
    c3=C(3);
    [u1 u2 u3 delta]=payoffs(v1,v2,v3,C(1),C(2),C(3),n);
    G1=zeros(n+1,1);
    G2=zeros(n+1,1);
    G3=zeros(n+1,1);
    S=zeros(n+1,1);
    G1(n+1)=1; 
    G2(n+1)=1;
    G3(n+1)=1;
    S1=(v1-u1)/c1;
    S3=S1-delta;
    l=S1/n;
    G1_high=@(s)((u2+c2*s-v2)/(v1-v2));
    G2_high=@(s)((u1+c1*s-v2)/(v1-v2));
    for i=1:n;
        S(i+1)=i*l;
    end;
    %Above S3, where G3 = 1, only players 1 and 2 interact with each other
    
    for i=1:n;
            if S(n + 1 - i)<S3;
                i_S3=n + 1 - i;
                break
            end;
            G1(n + 1 - i)=G1_high(S(n + 1 - i));
            G2(n + 1 - i)=G2_high(S(n + 1 - i));  
            G3(n + 1 - i)=1;
            i_S3=1;
    end;
    
    %Calculate G for s < S3    
    
    C = transpose(C);
    x1=G1(i_S3+1);
    x2=G2(i_S3+1);
    x3=G3(i_S3+1);
    i=i_S3+1;
   
    while x1 > 0;
        %define F matrix
        F=[               0            , ((v1-v2)-(v2-v3))*x3+(v2-v3), ((v1-v2)-(v2-v3))*x2+(v2-v3);
           ((v1-v2)-(v2-v3))*x3+(v2-v3),               0             , ((v1-v2)-(v2-v3))*x1+(v2-v3);
           ((v1-v2)-(v2-v3))*x2+(v2-v3), ((v1-v2)-(v2-v3))*x1+(v2-v3),               0            ];
        g=inv(F)*C;
        if x1-g(1)*l<0;
            break;
        end;
         if i==1;
            break;
        end;
        G1(i-1)=x1-g(1)*l;
        G2(i-1)=x2-g(2)*l;
        G3(i-1)=x3-g(3)*l;
        
        x1=x1-g(1)*l;
        x2=x2-g(2)*l;
        x3=x3-g(3)*l;
        i=i-1;
    end;
    clear x1 x2 x3 xs;
    
    
    %find the lower support of G1, denote it as s1:
    i_s1=i;
    s1=S(i_s1);

    %calculating the G2 G3 below s1 using a new grid l_low
    x2=G2(i_s1);
    x3=G3(i_s1);
    xs=S(i_s1);
    i=i_s1;
    C23=[C(2);C(3)];
    while x2 > 0;
        %define F matrix
         F=[   0   , (v2-v3);
           (v2-v3),    0   ];
        g=inv(F)*C23;
        if i==1;
            break;
        end;
        G2(i-1)=x2-g(1)*l;
        G3(i-1)=x3-g(2)*l;
        if x2-g(1)*l<0;
            break;
        else;
        
        x2=x2-g(1)*l;
        x3=x3-g(2)*l;
        i=i-1;
        end;
    end;

    %find the lower support of G2:
    i_s2=i;
   s2=S(i_s2);
   Splot=max(S);
   

    %Find the gap in the support of G3:
    [gaps3 G3hat gaps3index] = findgaps(S, G3);


%     figure(8);
%     plot(S(find(G1>0)),G1(find(G1>0)),'g');
%     hold on;
%     plot(S(find(G2<1)),G2(find(G2<1)),'b')
%     hold on;
%     plot(S(find(G3<1)),G3(find(G3<1)),'r')
%     hold on;
%     plot(S(find(G3<1)),G3hat(find(G3<1)),'--r')
%     hold off;
%     axis([0 Splot+0.1 -0.1 1.1]);
%     title('Plot after shift')

    G3 = G3hat;
    
%Recalculate the strategies G1 and G2 in the gap:
    
    for j = 1:(floor(length(gaps3)/2));
        for i=n+1-gaps3index(2*j):n-gaps3index(2*j-1);
            X1=G1(n+2-i);
            X2=G2(n+2-i);
            X3=G3(n+2-i);
            C12=[C(1);C(2)];
            %define F matrix
            F=[               0            , ((v1-v2)-(v2-v3))*X3+(v2-v3);
               ((v1-v2)-(v2-v3))*X3+(v2-v3),               0             ];
            g=inv(F)*C12;
            G1(n+1-i)=X1-g(1)*l;
            G2(n+1-i)=X2-g(2)*l;
        end;
    end;
%     

%     figure(9);
%     plot(S((find(G1>0))),G1(find(G1>0)),'g');
%     hold on;
%     plot(S(find(G2>0)),G2(find(G2>0)),'b')
%     hold on;
%     plot(S(find(G3<1)),G3(find(G3<1)),'r')
%     hold off;
%     axis([0 Splot 0 1]);
%     xlabel('performance');
%     legend({'Player 1','Player 2','Player 3'},'location','southeast')
%     title('Equilibrium Strategies')
    
    return;
end