%If v1=v2>v3, this program solve for G1, G2, G3 in the three-player contest
function [G1 G2 G3 S]=solveG2(v1,v2,v3,c1,c2,c3,n)

S1=(v1-v3)/c3;
u1=v1-c1*S1;
u2=v1-c2*S1;
u3=v3;

l=S1/n;

S=zeros(n+1,1);
G1=zeros(n+1,1);
G2=zeros(n+1,1);
G3=zeros(n+1,1);

G1(n+1)=1;
G2(n+1)=1;
G3(n+1)=1;
S(n+1)=S1;
for i=2:n+1;
    S(n+2-i) = (n+1-i)*l;
    s=S(n+2-i);
end;
%calculate G above s>s1
for i=2:n+1;
    s=S(n+2-i);
    X1=(v1-c1*s-u1)/(v1-v3);
    X2=(v1-c2*s-u2)/(v1-v3);
    X3=(v1-c3*s-u3)/(v1-v3);
    G1(n+2-i)=1-(X2*X3/X1)^0.5;
    G2(n+2-i)=1-(X1*X3/X2)^0.5;
    G3(n+2-i)=1-(X1*X2/X3)^0.5;
    if G1(n+2-i) < 0 
       break
    end;
end;
    
    %find the lower support of G1
    s1=s;
    s1_index=n+2-i;
    
    for j = 1:s1_index;
        G1(j) = 0; 
    end;
    
    %Calculate the strategies below the support of G1:
    for i=n+2-s1_index:n;
        X2=G2(n+2-i);
        X3=G3(n+2-i);
        C23=[c2;c3];
        %define F matrix
        F=[   0   , (v2-v3);
           (v2-v3),    0   ];
        g=inv(F)*C23;
        G2(n+1-i)=X2-g(1)*l;
        G3(n+1-i)=X3-g(2)*l;
    end;    
    
%     figure(9);
%     plot(S(s1_index+1:n+1),G1(s1_index+1:n+1),'g');
%     hold on;
%     plot(S,G2,'b')
%     hold on;
%     plot(S,G3,'r')
%     hold off;
%     Splot=S(n+1);
%     axis([0 Splot 0 1]);
%     xlabel('performance');
%     legend({'Player 1','Player 2','Player 3'},'location','southeast')
%     title('Equilibrium Strategies')
    
    return;
end