% findBR.m : find best response S3 and maximum u3 for player 3 given
% player 1 and 2 mixed strategies

function [S3 u3 S3_index]=findBR(W_3, G1, G2, S, S1, S1_l, c3)
%create cdf record matrices:
n = length(S);
W = zeros(n,1);

%find indices for S1 and S1_l
diff = (S - S1).^2;
S1_index=min(find(diff==min(diff)));
diff = (S - S1_l).^2;
S1_l_index=min(find(diff==min(diff)));

% expected winning of 3 against mixed strategies is 
    for i=1:n;
         W(i) = W_3(G1(i), G2(i),S(i))-c3*S(i);
    end;
    
%find best response and payoff
    [u3 sind] = max(W(S1_l_index:S1_index));
    S3_index = sind + S1_l_index - 1;
    S3 = S(sind + S1_l_index - 1);

%  figure(6);
%  plot(S(S1_l_index:S1_index), W(S1_l_index:S1_index));
%  axis([0 S(S1_index)+0.1 min(W(S1_l_index:S1_index)) max(W(S1_l_index:S1_index))]);
    
    return;
end
